﻿
Partial Class _Default
    Inherits System.Web.UI.Page
    Private dbContexto As New dbBancosDataContextDataContext
    Sub LimpiarCajasTexto()
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        TextBox5.Text = ""
        TextBox2.Focus()
    End Sub
    Sub HabilitarNuevo()
        btnAgregar.Enabled = True
        btnModificar.Enabled = False
        btnEliminar.Enabled = False
        LimpiarCajasTexto()
    End Sub
    Sub HabilitarExistente()
        btnAgregar.Enabled = False
        btnModificar.Enabled = True
        btnEliminar.Enabled = True
    End Sub
    Sub DesHabilitarBotones()
        btnAgregar.Enabled = False
        btnModificar.Enabled = False
        btnEliminar.Enabled = False
        LimpiarCajasTexto()
    End Sub
    Protected Sub btnAgregar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAgregar.Click
        Dim Clientes = New tbClientes
        Clientes.ClienteID = TextBox1.Text
        Clientes.Apellidos = TextBox2.Text
        Clientes.Nombre = TextBox3.Text
        Clientes.Direccion = TextBox4.Text
        Clientes.Telefono = TextBox5.Text
        dbContexto.tbClientes.InsertOnSubmit(Clientes)
        dbContexto.SubmitChanges()
        DesHabilitarBotones()
    End Sub

    Protected Sub btnConsultar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnConsultar.Click
        Try
            Dim BuscaCliente = (From Clientes In dbContexto.tbClientes _
                                  Where Clientes.ClienteID = TextBox1.Text).ToList()(0)
            'Carga los TextBox respectivos en caso de que haya una vinculacion objetos del modelo
            'con datos de la base de datos con la que se vincula
            TextBox2.Text = BuscaCliente.Apellidos
            TextBox3.Text = BuscaCliente.Nombre
            TextBox4.Text = BuscaCliente.Direccion
            TextBox5.Text = BuscaCliente.Telefono
            HabilitarExistente()
        Catch ex As Exception

            Response.Write("<script>alert('Número de cliente No encontrado!')</script>")
            'Permite que se hagan los cambios en el contexto de conexion
            HabilitarNuevo()
        End Try
    End Sub


    Protected Sub btnEliminar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnEliminar.Click
        Dim eliminaCliente = (From clientes In dbContexto.tbClientes _
                              Where clientes.ClienteID = (TextBox1.Text).ToList()(0))
        'se elimina el registro del contexto y de su referencia en la base de datos relacional
        dbContexto.tbClientes.DeleteOnSubmit(eliminaCliente)
        dbContexto.SubmitChanges()
        DesHabilitarBotones()
    End Sub

    Protected Sub btnModificar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnModificar.Click
        Dim modificaCliente = (From _clientes In dbContexto.tbClientes _
                         Where _clientes.ClienteID = TextBox1.Text _
                         Select _clientes).Single
        'se modifica el cliente en el contexto de datos y en su referencia de la base de datos relacional. 
        modificaCliente.Apellidos = TextBox2.Text
        modificaCliente.Nombre = TextBox3.Text
        modificaCliente.Direccion = TextBox4.Text
        modificaCliente.Telefono = TextBox5.Text
        dbContexto.SubmitChanges()
        DesHabilitarBotones()
    End Sub
End Class
